package com.laguerre.kan;

import java.nio.FloatBuffer;
import java.nio.ShortBuffer;

public abstract class Mesh extends Component {
	public static final int POSITION_DATA_SIZE = 4;
	public static final int NORMAL_DATA_SIZE = 3;
	public static final int UV_DATA_SIZE = 2;
	/** Adds bytes to get finally 4-bytes alignment (and better performances). */
	public static final int PADDING_DATA_SIZE = 3;

	public void init() {
	}

	public abstract int getNbOfSubMeshes();

	public int getVertexPackedDataSize(int subMeshId) {
		return POSITION_DATA_SIZE + NORMAL_DATA_SIZE + UV_DATA_SIZE + PADDING_DATA_SIZE;
	}

	public abstract int getVertexCount(int subMeshId);

	public abstract FloatBuffer getSharedVertexPackedData(int subMeshId);

	public abstract int getDrawListCount(int subMeshId);

	public abstract ShortBuffer getSharedDrawListBuffer(int subMeshId);
}
